<template>
    <div>
        <slot></slot>

        <b-form-group
            label="Company name"
            label-for="name"
        >
            <b-form-input
                id="name"
                name="name"
                v-model="entity.name"
                :class="{'is-invalid': errors.has('name') }"
                v-validate="'required'"
            />

            <div v-if="errors.has('name:required')" class="text-danger">
                Required field
            </div>
        </b-form-group>

        <b-form-group
            label="Company description"
            label-for="description"
        >
            <b-form-input
                id="description"
                name="description"
                v-model="entity.description"
            />
        </b-form-group>

        <b-form-group
            label="Company logo"
            label-for="logo"
        >
            <b-form-input
                id="logo"
                name="logo"
                v-model="entity.logo"
                :class="{'is-invalid': errors.has('logo') }"
                v-validate="{ required: true, regex: /^(https?):\/\/(-\.)?([^\s\/?\.#-]+\.?)+(\/[^\s]*)?$/i }"
            />

            <div v-if="errors.has('logo:required')" class="text-danger">
                Required field
            </div>
            <div v-if="errors.has('logo:regex')" class="text-danger">
                Wrong URL format
            </div>
        </b-form-group>

        <b-form-group
            label="Company policy cost (In cents)"
            label-for="policy_cost"
        >
            <b-form-input
                id="policy_cost"
                name="policy_cost"
                v-model="entity.policy_cost"
                v-validate="'numeric'"
                :class="{'is-invalid': errors.has('policy_cost') }"
            />

            <div v-if="errors.has('policy_cost:numeric')" class="text-danger">
                Is not a number
            </div>
        </b-form-group>
        <div class="d-flex justify-content-end">
            <button type="button" class="btn btn-primary" @click="validate">
                OK
            </button>
        </div>
    </div>
</template>

<script lang="ts">
    import Vue from 'vue'
    import Component from 'vue-class-component'
    import { Model } from 'vue-property-decorator'
    import CompanyPresenter from '../../../presenters/companies/CompanyPresenter'
    import { ListCompanyInterface } from '../../../interfaces/companies/CompanyInterface'

    @Component({})
    export default class CompanyForm extends Vue {
        @Model('on-valid', { type: Object }) entity!: ListCompanyInterface

        presenter = new CompanyPresenter

        validate() {
            this.$validator.validateAll().then(result => {
                if (result) {
                    this.$emit('on-valid', this.presenter.store(this.entity))
                }
            })
        }
    }
</script>